gtaScnAttrib = attributes gtaScnData
attribID:#(0x5edb9923, 0x5b889f18)
(
	parameters main rollout:params (
		exportdir type:#string ui:edt_txd default:"C:\\"
		baseID type:#integer ui:spn_id default:1000
		sceneName type:#string ui:edt_scn default:"untitled"
	)
	rollout params "GTA Scene" (
		edittext edt_scn "Scene name"
		edittext edt_txd "Export"
		button btn_browse "Browse"
		spinner spn_id "ID" type:#integer range:[0,100000,1000]
		on btn_browse pressed do (
			path = getSavePath()
			if path != undefined do
				exportdir = path
		)
	)
)

fn needSceneAttribs = (
	if(custAttributes.get rootnode gtaScnAttrib) == undefined do
		custAttributes.add rootnode gtaScnAttrib
)

fn openSceneRollout = (
	needSceneAttribs()
	ro = rootnode.gtaScnData.params
	createDialog ro width:400
)

gtaAttrib = attributes gtaData
attribID:#(0x4ecfe9a2, 0x6db18619)
(
	parameters main rollout:params (
-- 		hack type:#integer
		id type:#integer ui:spn_type default:0
		dist type:#integer ui:spn_dist default:100
		txd type:#string ui:edt_txd default:"CHANGEME"
		flg_road type:#boolean ui:chk_road default:false
		flg_nofade type:#boolean ui:chk_nofade default:false
		flg_blend type:#boolean ui:chk_blend default:false
		flg_additive type:#boolean ui:chk_additive default:false
		flg_tunnel type:#boolean ui:chk_tunnel default:false
		flg_light type:#boolean ui:chk_light default:false
		flg_noz type:#boolean ui:chk_noz default:false
		timed type:#boolean ui:chk_timed default:false
		timeon type:#integer ui:spn_tmon default:0
		timeoff type:#integer ui:spn_tmoff default:23
	)
	 
	rollout params "Gta Object" (
		spinner spn_type "ID" type:#integer range:[0,10000,0]
		edittext edt_txd "TXD"
		spinner spn_dist "LOD distance" type:#integer range:[0,10000,100]
		checkbox chk_road "Normal cull"
		checkbox chk_nofade "Do not fade"
		checkbox chk_blend "Draw last"
		checkbox chk_additive "Additive"
		checkbox chk_tunnel "Is Subway"
		checkbox chk_light "Ignore Lighting"
		checkbox chk_noz "No Zbuffer write"
		checkbox chk_timed "Is time object"
		spinner spn_tmon "Time on" type:#integer range:[0,23,0] enabled:false
		spinner spn_tmoff "Time off" type:#integer range:[0,23,23] enabled:false
		on chk_timed changed state do (
			spn_tmon.enabled = state
			spn_tmoff.enabled = state
		)
	)
)

colAttrib = attributes colData
attribID:#(0x19cb2748, 0x358e9f50)
(
	parameters main rollout:params (
		surf type:#integer ui:spn_surf default:0
		piece type:#integer ui:spn_piece default:0
	)
	 
	rollout params "Gta Collision" (
		spinner spn_surf "Surface Type" type:#integer range:[0,10000,0]
		spinner spn_piece "Piece Type" type:#integer range:[0,10000,0]
	)
)

fn makeColObject obj = (
	obj.material = undefined
	if (custAttributes.get obj colAttrib) != undefined do
		return obj
	case classOf obj of (
	Sphere: obj.name = (uniquename "Collision_Sphere")
	Box: obj.name = (uniquename "Collision_Box")
	Editable_Poly: obj.name = (uniquename "Collision_Mesh")
	Editable_Mesh: obj.name = (uniquename "Collision_Mesh")
	default:
		if superClassOf obj == GeometryClass then
			obj.name = (uniquename "Collision_Mesh")
		else
			return obj
	)
	obj.wirecolor = (color 0 100 255 255)
	obj.renderable = false
	custAttributes.add obj colAttrib
	custAttributes.delete obj gtaAttrib
)

fn setTimed attr state = (
	attr.timed = state
	attr.params.spn_tmon.enabled = state
	attr.params.spn_tmoff.enabled = state
)

fn rxmatch s pat = (
	rx = dotNetClass "System.Text.RegularExpressions.RegEx"
	(rx.match s pat).success
)

-- get base model name by stripping _L[0-2]
fn modelName name = (
	-- be careful since imported names might have been truncated
	if rxmatch name "_[Ll][012]$" then
		substring name 1 (name.count-3)
	else if rxmatch name "_[Ll]$" then
		substring name 1 (name.count-2)
	else if rxmatch name "_$" then
		substring name 1 (name.count-1)
	else
		name
)

-- get number of model from _L[0-2] part of name
fn modelNum name = (
	if rxmatch name "_[Ll][012]$" then
		(substring name name.count -1) as integer
	else
		0
)

-- return argument if _L0 not found
fn getNthModel obj n = (
	nname = (modelName obj.name) + "_L" + (n as string)
	node = getnodebyname nname
	if node == undefined and n == 0 then obj else node
)

fn getFlags attr = (
	flag = 0
	if attr.flg_road			do flag = bit.or flag 0x01
	if attr.flg_nofade		do flag = bit.or flag 0x02
	if attr.flg_blend		do flag = bit.or flag 0x04
	if attr.flg_additive	do flag = bit.or flag 0x08
	if attr.flg_tunnel		do flag = bit.or flag 0x10
	if attr.flg_light			do flag = bit.or flag 0x20
	if attr.flg_noz			do flag = bit.or flag 0x40
	flag as string
)

fn setFlags attr flag = (
	attr.flg_road 		= (bit.and flag 0x01) != 0
	attr.flg_nofade 	= (bit.and flag 0x02) != 0
	attr.flg_blend 		= (bit.and flag 0x04) != 0
	attr.flg_additive 	= (bit.and flag 0x08) != 0
	attr.flg_tunnel 	= (bit.and flag 0x10) != 0
	attr.flg_light 		= (bit.and flag 0x20) != 0
	attr.flg_noz 		= (bit.and flag 0x40) != 0
)

fn isMapObj obj = (
	classof obj != XRefObject and
	(custAttributes.get obj gtaAttrib) != undefined
)

fn isInst obj = (
	((custAttributes.get obj gtaAttrib) != undefined) or
	(classof obj == XRefObject) and ((custAttributes.get (obj.getSrcItem()) gtaAttrib) != undefined)
)

fn checkIDs = (
	objs = #()
	errorobjs = #()
	for o in objects do
		if isMapObj o and (modelNum o.name) == 0 do (
			if o.id > 0 then (
				if objs[o.id] != undefined do (
					format "warning: ID % used by %, last object with this ID %\n" o.id o.name objs[o.id]
					append errorobjs o
				)
				objs[o.id] = o.name
			) else (
				format "warning: object % has ID 0\n" o.name
				append errorobjs o
			)
		)
	if errorobjs.count == 0 then
		format "all fine :)\n"
	else
		select errorobjs
)

-- return objects with ID 0
fn getUndefinedObjs = (
 	for o in objects where (isMapObj o and o.id == 0 and (modelNum o.name) == 0) collect o
)

-- assign consecutive IDs to all map objects
fn assignIDs id = (
	for o in objects where isMapObj o do
		if (modelNum o.name) == 0 then (
			o.id = id
			id += 1
		) else
			o.id = 0
	format "next ID: %\n" id
)

-- original instance is last in the array
--   removed: III doesn't use instances
-- fn getCanonical obj = (
-- 	InstanceMgr.GetInstances obj &is
-- 	is[is.count]
-- )

fn numAtomics obj = (
	p = obj
	while p.parent != undefined do p = p.parent

	if (superclassof p == GeometryClass) do
		return 1
	n = 0
	for c in p.children where (superclassof c == GeometryClass) do
		n += 1
	n
)

fn makeIdeLine obj = (
	ss = stringStream ""
-- 	obj = getCanonical obj
	objs = for o in (for n = 0 to 2 collect getNthModel obj n) where o != undefined collect o
	format "%, %, %, %, " obj.id (modelname obj.name) obj.txd objs.count to:ss
	for o in objs do
		format "%, " o.dist to:ss
	format "%" (getflags obj) to:ss
	if obj.timed do
		format ", %, %" obj.timeon obj.timeoff to:ss
	ss as string
)

fn numStr num = (
	i = num as integer
	if (i as float) == num then i as string
	else num as string
)

fn makeIplLine inst = (
	if classOf inst == XRefObject then (
		name = inst.objectName
		attr = custAttributes.get (inst.getSrcItem()) gtaAttrib
	) else (
		InstanceMgr.GetInstances inst &is
		name = is[is.count].name
		attr = custAttributes.get inst gtaAttrib
	)
	ss = StringStream ""
	format "%, %, %, %, %, %, %, %, %, %, %, %" \
		attr.id (modelName name) \
		(numStr inst.pos.x) (numStr inst.pos.y) (numStr inst.pos.z) \
		(numStr inst.scale.x) (numStr inst.scale.y) (numStr inst.scale.z) \
		(numStr inst.rotation.x) (numStr inst.rotation.y) \
		(numStr inst.rotation.z) (numStr inst.rotation.w) to:ss
	ss as string
)

fn cmpid o1 o2 = (
	o1.id - o2.id
)

fn printDeflist list out = (
	curid = -1
	format "objs\n" to:out
	for obj in list do (
		if curid < obj.id and not obj.timed do
			format "%\n" (makeIdeLine obj) to:out
		curid = obj.id
	)
	format "end\n" to:out
	format "tobj\n" to:out
	curid = -1
	for obj in list do (
		if curid < obj.id and obj.timed do
			format "%\n" (makeIdeLine obj) to:out
		curid = obj.id
	)
	format "end\n" to:out
	OK
)

fn printDefinitions out = (
	objs = for obj in objects where (isMapObj obj) and (modelNum obj.name) == 0 collect obj
	qsort objs cmpid
	printDeflist objs out
)

fn saveIDE filename = (
	out = openFile filename mode:"w"
	if out == undefined do
		return 0
	printDefinitions out
	close out
)
-- filename = getsavefilename()
-- saveIDE filename

fn printInstances out = (
	insts = for inst in objects where (isInst inst) and (modelNum inst.name) == 0 collect inst
	format "# IPL generated from Max file %\n" maxFileName to:out
	format "inst\n" to:out
	for i in insts do
		format "%\n" (makeIplLine i) to:out
	format "end\n" to:out
	OK
)

fn saveIPL filename = (
	out = openFile filename mode:"w"
	if out == undefined do
		return 0
	printInstances out
	close out
)
-- filename = getsavefilename()
-- saveIPL filename

fn exportScene = (
	if(custAttributes.get rootnode gtaScnAttrib) == undefined do (
		openSceneRollout()
		return 0
	)
	colpath = rootnode.exportdir + "\\col"
	if (makeDir colpath all:true) == false do (
		format "error: cannot create dir %\n" colpath
		return 0
	)
	dffpath = rootnode.exportdir + "\\dff"
	if (makeDir dffpath all:true) == false do (
		format "error: cannot create dir %\n" dffpath
		return 0
	)
	showprompt = true
	tmp = selection as array
	objs = for obj in objects where (isMapObj obj) and (modelNum obj.name) == 0 collect obj
	qsort objs cmpid
	for obj in objs do (
		name = modelName obj.name
		models = for o in (for n = 0 to 2 collect getNthModel obj n) where o != undefined collect o
		nmodels = models.count
		format "exporting: % % %\n" obj.id name nmodels
		-- Collision
		select obj
		exportFile (colpath + "\\" + name + ".col") #noprompt using:GTA_Collision
--  		exportCOL1 (colpath + "\\" + name + ".col") name
 		-- Model
		select obj
		dff = dffpath + "\\" + name + ".dff"
		if nmodels > 1 do
			gr = group models
		if showprompt then
			exportFile dff using:RenderWare_modelExporterPlugin
		else
			exportFile dff #noprompt using:RenderWare_modelExporterPlugin
		if nmodels > 1 do
			ungroup gr
		showprompt = false
	)
	saveIDE (rootnode.exportdir + "\\" + rootnode.sceneName  + ".ide")
	saveIPL (rootnode.exportdir + "\\" + rootnode.sceneName  + ".ipl")
	clearNodeSelection()
	select tmp
)
-- exportScene()