dffdir = ""
modelInfo = #()

fn rootOf obj = (
	while obj.parent != undefined do obj = obj.parent
	obj
)

fn headOf obj = (
	root = rootOf obj
	if superClassOf root == GeometryClass do
		return root
	for c in root.children do
		if matchPattern c.name pattern:"*_L0" do
			return c
	undefined
)

fn deleteDummies root = (
	for c in root.children do (
		deleteDummies c
		if classOf c == Dummy do
			delete c
	)
)

-- just import the _L0 object
fn importMapDffSingleObject name = (
	dffImp.prepend = 1
	dffImp.autosmooth = 1
	dffImp.smoothingAngle = 10
	dffImp.convertHierarchy = 1
	importFile name #noPrompt using:RenderWare_model
	selectImportedDff()
	for s in selection do
		s.name = substring s.name 2 -1
	x = rootOf $selection[1]
	head = headOf x
	del = for o in $selection where o != head collect o
	delete del
	head.position = [0, 0, 0]
	return head
)

fn importMapDff name = (
	dffImp.prepend = 1
	dffImp.autosmooth = 1
	dffImp.smoothingAngle = 10
	dffImp.convertHierarchy = 1
	importFile name #noPrompt using:RenderWare_model
	selectImportedDff()
	for s in selection do
		s.name = substring s.name 2 -1
	x = rootOf $selection[1]
	children = for c in x.children collect c
	head = headOf x
	if classOf x == Dummy do (
		myname = x.name
		trans = x.transform
		delete x
		x = dummy name:myname
		x.transform = head.transform
		for c in children do
			attachObjects x c move:false
		x.transform = trans
-- 		g = group $selection name:myname
-- 		setGroupOpen g true
-- 		x = rootOf $selection[1]
	)
 	deleteDummies x
	return x
)

fn placeObject obj = (
	global lastobj
	obj = rootOf obj
	if lastobj != undefined do (
		obj.pos.y = -obj.min.y + lastobj.max.y + 10
	)
	lastobj = obj
)

fn objsLine line = (
	dist = #()
	id = readValue line
	model = trimleft (readDelimitedString line ",")
	texdict = trimleft (readDelimitedString line ",")
	nobj = readValue line
	for i = 1 to nobj do
		dist[i] = readValue line
	flags = readValue line

	dffpath = dffdir + model + ".dff"
	root = importMapDff dffpath
	obj = headOf root
-- 	custAttributes.add obj gtaAttrib

-- 	c = findCol coldict model
-- 	if c != undefined do  (
-- 		objs = createColF c.file c.val
-- 		layer = LayerManager.getLayerFromName "Collision"
-- 		if layer == undefined do
-- 			layer = LayerManager.newLayerFromName "Collision"
-- 		for o in objs do (
-- 			layer.addNode o
-- 			attachObjects obj o move:false
-- 		)
-- 	)

-- 	obj.id = id
-- 	obj.txd = texdict
-- 	obj.dist1 = dist[1]
-- 	if nobj > 1 do obj.dist2 = dist[2]
-- 	if nobj > 2 do obj.dist3 = dist[3]
-- 	setFlags obj flags
	modelInfo[id] = obj
	placeObject obj
	obj
)

fn readIDE filename = (
	sections = #("objs", "tobj", "path", "2dfx", "end")
	inf = openFile filename
	if inf == undefined do
		return 0
	sect = #end
	global lastobj = undefined
	while not eof inf do (
		line = readline inf
		if line == "" or line[1] == "#" do
			continue
		i = findItem sections line
		if i > 0 do (
			sect = sections[i] as name
-- 			print sect
			continue
		)
		print line
		case sect of (
		#objs: objsLine (line as stringstream)
-- 		#tobj: tobjLine (line as stringstream)
-- 		#path: pathLine (line as stringstream) inf
-- 		#2dfx: twodfxLine (line as stringstream)
		)
	)
	close inf
)

fn instLineDumb line = (
	ln = line as string
	id = readValue line
	model = trimleft (readDelimitedString line ",")
	x = readValue line
	y = readValue line
	z = readValue line
	pos =  [x, y, z]
	x = readValue line
	y = readValue line
	z = readValue line
	scl = [x, y, z]
	x = readValue line
	y = readValue line
	z = readValue line
	w = readValue line
	rot = (quat x y z -w)
	inst = importMapDffSingleObject (dffdir + model + ".dff")
	if inst != undefined do (
		inst.rotation = rot
		inst.scale = scl
		inst.pos = pos
	)
)

fn cullLine line = (
	ln = line as string

	posx = readValue line
	posy = readValue line
	posz = readValue line
	minx = readValue line
	miny = readValue line
	minz = readValue line
	maxx = readValue line
	maxy = readValue line
	maxz = readValue line
	flags = readValue line
	wanted = readValue line
	
	width  = maxx-minx
	length = maxy-miny
	height = maxz-minz
	box width:width length:length height:height pos:[minx+width/2, miny+length/2, minz+height/2]
)

fn readIPLdumb filename = (
		sections = #("inst", "cull", "pick", "end")
	inf = openFile filename
	if inf == undefined do
		return 0
	sect = #end
	global insts = #()
	while not eof inf do (
		line = readline inf
		if line == "" or line[1] == "#" do
			continue
		i = findItem sections line
		if i > 0 do (
			sect = sections[i] as name
			continue
		)
		case sect of (
		#inst: instLineDumb (line as stringstream)
		#cull: cullLine (line as stringstream)
		)
	)
	close inf
)

--dffdir = "D:/rockstargames/ps2/gta3/MODELS/gta3_archive/"

-- readIDE "C:/Users/aap/Desktop/3map/test.ide"

-- importMapDff (dffdir + "/railtrax_straight.dff")
-- importMapDff (dffdir + "/Chinabuilds09.dff")
-- importMapDff (dffdir + "/Chinabuilds08.dff")
-- importMapDff (dffdir + "/Chinabuilds05.dff")
-- importMapDff (dffdir + "/Chinabuilds07.dff")
-- importMapDff (dffdir + "/chinabuildorn.dff")
-- importMapDff (dffdir + "/Chinabuilds21.dff")
-- importMapDff (dffdir + "/ind_land070.dff")

-- importMapDffSingleObject (dffdir + "/railtrax_straight.dff")
-- ipl = getopenfilename()

dffdir = "C:/Users/aap/games/gta3/models/gta3_archive/"
--readIPLdumb "C:/Users/aap/games/gta3/data/maps/comsw/comSW.ipl"
--readIPLdumb "C:/Users/aap/games/gta3/data/maps/industsw/industsw.ipl"
--readIPLdumb "C:/Users/aap/games/gta3/data/maps/industse/industse.ipl"
--readIPLdumb "C:/Users/aap/games/gta3/data/maps/industnw/industnw.ipl"
--readIPLdumb "C:/Users/aap/games/gta3/data/maps/industne/industne.ipl"
--readIPLdumb "C:/Users/aap/games/gta3/data/maps/indroads/indroads.ipl"
readIPLdumb "C:/Users/aap/games/gta3/data/maps/comntop/comntop.ipl"

-- readIPLdumb "C:/Users/aap/games/gta3/data/maps/cull.ipl"